package com.gyee.edge.loader.rocketmq.comuser;

import com.google.protobuf.InvalidProtocolBufferException;
import com.gyee.edge.common.utils.util.ProtoJsonUtil;
import com.gyee.edge.loader.golden.DataWrite;
import com.gyee.edge.loader.protobuf.UserProto;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.consumer.DefaultMQPushConsumer;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyContext;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyStatus;
import org.apache.rocketmq.client.consumer.listener.MessageListenerConcurrently;
import org.apache.rocketmq.common.message.MessageExt;
import org.apache.rocketmq.common.protocol.heartbeat.MessageModel;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Slf4j
@Component
public class BalanceComuser {

    private DataWrite dataWrite;
        public void DataConsumer() throws Exception {
            DefaultMQPushConsumer consumer = new DefaultMQPushConsumer("group_sonsumer");
            consumer.setNamesrvAddr("127.0.0.1:9876");
            consumer.subscribe("keyMessage", "*");
            consumer.setMessageModel(MessageModel.CLUSTERING);
            consumer.registerMessageListener(new MessageListenerConcurrently() {
                @Override
                public ConsumeConcurrentlyStatus consumeMessage(List<MessageExt> msgs, ConsumeConcurrentlyContext consumeConcurrentlyContext) {
                    try {
                        for (MessageExt msg : msgs) {
                            String topic = msg.getTopic();
                            //String msgBody = new String(msg.getBody(), "utf-8");
                            String tags = msg.getTags();
                            try {
                                //反序列化
                                Date st = new Date();
                                System.out.println("反序列化前时间"+(st.getTime()));
                                UserProto.User user1 = UserProto.User.parseFrom(msg.getBody());
                                String jsonObject = ProtoJsonUtil.toJson(user1);
                                log.info("收到消息" + "topic" + topic + ",tags" + tags + ",msg" + user1);
                                //数据写入
                                Date et = new Date();
                                System.out.println("反序列化后时间"+(et.getTime()));
                                System.out.println("序列化时间"+(et.getTime()-st.getTime()));
                                dataWrite.DataWriteGloden(jsonObject);
                            } catch (InvalidProtocolBufferException e) {
                                e.printStackTrace();
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        return ConsumeConcurrentlyStatus.RECONSUME_LATER;
                    }
                    return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
                }
            });
            consumer.start();  //启动消费者
            log.info("Consumer STARTTED");
        }

    public void setWriteGolden(DataWrite dataWrite) {
        this.dataWrite = dataWrite;
    }
}
